﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr112_1
{
    class Program
    {
        // Класс с перегрузкой операторов сравнения == и != 
        //и переопределением методов GetHashCode() и Equals(): 
        class MyClass {
            // Целочисленное поле: 
            public int code;
            // Символьное поле: 
            public char symb;
            // Конструктор с двумя аргументами: 
            public MyClass(int n, char s) {
                code = n; // Значение целочисленного поля
                symb = s; // Значение символьного поля
            }

            // Переопределение метода GetHashCode():
            public override int GetHashCode() {
                // Вычисление хэш-кода: 
                return code ^ symb;
            }

            // Переопределение метода Equals():
            public override bool Equals(Object obj) {
                // Локальная объектная переменная:
                MyClass t = (MyClass)obj;
                // Результат метода:
                if ( code == t.code && symb == t.symb) 
                    return true; 
                else return false;
            }

            // Перегрузка оператора "равно": 
            public static bool operator==(MyClass a, MyClass b) { 
                // Вызов метода Equals():
                return a.Equals(b);
            }

            // Перегрузка оператора "не равно": 
            public static bool operator!=(MyClass a, MyClass b) { 
                // Использование оператора "равно": 
                return !(a==b);
            }
        }

        // Класс с главным методом: 
        static void Main()
        {
            // Создание объектов:
            MyClass A = new MyClass(100, 'A');
            MyClass B = new MyClass(100, 'B');
            MyClass C = new MyClass(200, 'A');
            MyClass D = new MyClass(100, 'A');
            // Вычисление хэш-кодов:
            Console.WriteLine("Хэш-код A: {0}", A.GetHashCode()); 
            Console.WriteLine("Хэш-код В: {0}", B.GetHashCode()); 
            Console.WriteLine("Хэш-код C: {0}", C.GetHashCode());
            Console.WriteLine("Хэш-код D: {0}", D.GetHashCode()); 
            // Сравнение объектов на предмет 
            // равенства и неравенства:
            Console.WriteLine("А==В дает {0}", A==B);
            Console.WriteLine("А!=В дает {0}", A!=B);
            Console.WriteLine("А==С дает {0}", A==C);
            Console.WriteLine("А!=С дает {0}", A!=C);
            Console.WriteLine("A==D дает {0}", A==D);
            Console.WriteLine("A!=D дает {0}", A!=D);
            // Задержка:
            Console.ReadLine();
        }
    }
}
